/*
 * The olsr.org Optimized Link-State Routing daemon (olsrd)
 * Copyright (c) 2004, Thomas Lopatic (thomas@lopatic.de)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 * * Redistributions of source code must retain the above copyright 
 *   notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright 
 *   notice, this list of conditions and the following disclaimer in 
 *   the documentation and/or other materials provided with the 
 *   distribution.
 * * Neither the name of olsr.org, olsrd nor the names of its 
 *   contributors may be used to endorse or promote products derived 
 *   from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Visit http://www.olsr.org for more information.
 *
 * If you find this software useful feel free to make a donation
 * to the project. For more information see the website or contact
 * the copyright holders.
 *
 * $Id: log.c,v 1.4 2004/11/21 01:21:10 tlopatic Exp $
 */

#include "../log.h"

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#define LOGBUFSIZE	4096
char logbuf[LOGBUFSIZE];

FILE* logfile = NULL;

void olsr_openlog(const char *Id)
{
	snprintf(logbuf, LOGBUFSIZE, "%s.log", Id);
	
	logfile = fopen(logbuf, "w");
	if (logfile == 0) {
		fprintf(stderr, "Could not open %s\n", Id);
		exit(EXIT_FAILURE);
  	
	}
	
	olsr_syslog(OLSR_LOG_INFO, "olsrd started");
}

void olsr_syslog(int Level, char *Format, ...)
{
	// TODO: evaluate debug level
 	va_list arglist;
	
	snprintf(logbuf, LOGBUFSIZE, "[%d] %s\n", Level, Format);
	
	va_start(arglist, Format);
	vfprintf(logfile, logbuf, arglist);
	va_end(arglist);
	
	fflush(logfile);
}
